#include "Flipbook.h"

Flipbook :: Flipbook() : Switch()
{
	m_MaxNode = 0;
	m_Count = 0;
}

void Flipbook::IncreaseCount() 
{
	m_Count++;
	if (m_Count >= m_MaxNode) m_Count = 0;
}

void Flipbook::SwitchToNextNode() 
{
	IncreaseCount();
	setSingleChildOn(m_Count);
}

void Flipbook::LoadModels(char *prefix, char *ext, int maxNode) 
{
	char temp[100];

	m_MaxNode = maxNode;
	for (int i = 0; i < maxNode; i++) {
		sprintf(temp, "%s_%02d.%s", prefix, i + 1, ext);
		osg::ref_ptr<osg::Node> t = osgDB::readNodeFile(temp);
		addChild(t.get(), false);
	}
	setSingleChildOn(0);
	setDataVariance(osg::Object::DYNAMIC);
}

void FlipBookAnimationCallback::operator()(osg::Node* node, osg::NodeVisitor* nv) 
{
	Flipbook *f = dynamic_cast<Flipbook *>(node);
	if (f) {
		struct _timeb t;

		_ftime(&t);
		if ((t.time + t.millitm / 1000.) > (m_LastTime.time + (m_LastTime.millitm + ANIMATION_RATE) / 1000.)) {
			//if (fish.count >= fish.maxCount) fish.count = 0;
			//fish.sw->setSingleChildOn(fish.count);
			//fish.count++;
			f->SwitchToNextNode();
			m_LastTime = t;
			//lastTime.time = t.time;
			//lastTime.millitm = t.millitm;
		}
	}
	traverse(node, nv);
}
