#ifndef __FLIPBOOK_H__
#define __FLIPBOOK_H__

#include <osg/Node>
#include <osg/Switch>
#include <osgDB/ReadFile>
#include <sys/timeb.h>

#define ANIMATION_RATE 200

class Flipbook : public osg::Switch
{
protected:
	int m_Count;
	int m_MaxNode;
	void IncreaseCount() ;

public:
	Flipbook();
	void SwitchToNextNode();
	void LoadModels(char *prefix, char *ext, int maxNode);
};

class FlipBookAnimationCallback : public osg::NodeCallback 
{
protected:
	struct _timeb m_LastTime;
	int m_AnimationRate;

public:
	FlipBookAnimationCallback::FlipBookAnimationCallback(int animationRate) : m_AnimationRate(animationRate) { _ftime(&m_LastTime); };

	virtual void operator()(osg::Node* node, osg::NodeVisitor* nv);
};

#endif